# ʹ÷: irm "https://git.xykqyy.com/ljp/hostSync/raw/branch/main/install.ps1" | iex

# ϸģʽʹ
Set-StrictMode -Version 3.0
$ErrorActionPreference = 'Stop'

# Ĭ
$Version = 'latest'
$InstallDir = "$env:USERPROFILE\.hostsync\bin"
$NoInit = $false
$Portable = $false

# ɫ
function Write-ColorOutput {
    param([string]$Message, [string]$Color = 'White')
    Write-Host $Message -ForegroundColor $Color
}

function Write-Success { param([string]$Message) Write-ColorOutput $Message 'Green' }
function Write-Info { param([string]$Message) Write-ColorOutput $Message 'Cyan' }
function Write-Warning { param([string]$Message) Write-ColorOutput $Message 'Yellow' }
function Write-Error { param([string]$Message) Write-ColorOutput $Message 'Red' }

# ԱȨ
function Test-Administrator {
    $currentUser = [Security.Principal.WindowsIdentity]::GetCurrent()
    $principal = New-Object Security.Principal.WindowsPrincipal($currentUser)
    return $principal.IsInRole([Security.Principal.WindowsBuiltInRole]::Administrator)
}

# ȡ°汾
function Get-LatestVersion {
    try {
        Write-Info '? ȡ°汾Ϣ...'
        $api = 'https://git.xykqyy.com/api/v1/repos/ljp/hostSync/releases/latest'
        $response = Invoke-RestMethod -Uri $api -ErrorAction Stop
        return $response.tag_name
    }
    catch {
        Write-Warning '??  ޷ȡ°汾ʹ v1.0.0'
        return 'v1.0.0'
    }
}

# ϵͳܹ
function Get-Architecture {
    $arch = $env:PROCESSOR_ARCHITECTURE
    switch ($arch) {
        'AMD64' { return 'amd64' }
        'x86' { return '386' }
        'ARM64' { return 'arm64' }
        default { return 'amd64' }
    }
}

# ļ
function Get-FileFromUrl {
    param([string]$Url, [string]$Output)

    Write-Info "? : $(Split-Path $Output -Leaf)"
    Write-Info "? ַ: $Url"
    
    try {
        # ʹ Invoke-WebRequest 
        $ProgressPreference = 'SilentlyContinue'
        Invoke-WebRequest -Uri $Url -OutFile $Output -ErrorAction Stop
        $ProgressPreference = 'Continue'
        
        if (Test-Path $Output) {
            $size = [math]::Round((Get-Item $Output).Length / 1MB, 2)
            Write-Success "?  ($size MB)"
            return $true
        }
    }
    catch {
        Write-Error "? IWR ʧ: $($_.Exception.Message)"
        # ʹ curl Ϊ÷
        Write-Info '? ʹ curl...'
        try {
            $curlArgs = @('-L', $Url, '-o', $Output, '--silent', '--show-error')
            $curlProcess = Start-Process -FilePath 'curl.exe' -ArgumentList $curlArgs -Wait -PassThru -WindowStyle Hidden
            
            if ($curlProcess.ExitCode -eq 0 -and (Test-Path $Output)) {
                Write-Success '? ʹ curl '
                return $true
            }
            else {
                Write-Error "? curl ˳: $($curlProcess.ExitCode)"
            }
        }
        catch {
            Write-Error "? curl ִʧ: $($_.Exception.Message)"
        }
    }
    
    return $false
}

# 鲢жз
function Remove-ExistingService {
    Write-Info '? аװ...'
    
    #  PATH е hostsync
    $existingPath = $null
    $pathDirs = $env:PATH -split ';'
    foreach ($dir in $pathDirs) {
        $testPath = Join-Path $dir 'hostsync.exe'
        if (Test-Path $testPath) {
            $existingPath = $testPath
            break
        }
    }
    
    # Ĭϰװλ
    if (-not $existingPath) {
        $defaultPath = "$env:USERPROFILE\.hostsync\bin\hostsync.exe"
        if (Test-Path $defaultPath) {
            $existingPath = $defaultPath
        }
    }
    
    if ($existingPath) {
        Write-Info "? аװ: $existingPath"
        
        try {
            # ֹͣжط
            Write-Info '??  ֹͣз...'
            $stopArgs = @{
                FilePath               = $existingPath
                ArgumentList           = @('service', 'stop')
                Wait                   = $true
                PassThru               = $true
                RedirectStandardOutput = $true
                RedirectStandardError  = $true
                WindowStyle            = 'Hidden'
            }
            Start-Process @stopArgs | Out-Null
            
            Write-Info '??  жз...'
            $uninstallArgs = @{
                FilePath               = $existingPath
                ArgumentList           = @('service', 'uninstall')
                Wait                   = $true
                PassThru               = $true
                RedirectStandardOutput = $true
                RedirectStandardError  = $true
                WindowStyle            = 'Hidden'
            }
            Start-Process @uninstallArgs | Out-Null
            
            Write-Success '? з'
        }
        catch {
            Write-Warning "??  зʱִ: $($_.Exception.Message)"
            Write-Info '? װ...'
        }
        
        # ȴһȷȫֹͣ
        Start-Sleep -Seconds 2
    }
    else {
        Write-Info '? δаװ'
    }
}

# װ
function Install-HostSync {
    Write-ColorOutput @'
? HostSync ٰװű
===============================
ǿ Hosts ļ

ص:
- ? ֿ Hosts 
- ?  DNS 
- ? ʱԶ
- ? ̨

'@ 'Magenta'

    # 鲢жз
    Remove-ExistingService

    # ԱȨ
    if (-not (Test-Administrator)) {
        Write-Warning '??  δ⵽ԱȨޣװ'
        Write-Info '? 谲װԺԹԱ: hostsync service install'
        $NoInit = $true
    }

    # ȷ汾
    if ($Version -eq 'latest') {
        $Version = Get-LatestVersion
    }
    Write-Info "? װ汾: $Version"# 汾Ÿʽ - ȷvǰ׺tagȥvǰ׺ļ
    $TagVersion = $Version
    $FileVersion = $Version
    if ($Version -match '^v(\d+\.\d+\.\d+)$') {
        $TagVersion = $Version
        $FileVersion = $matches[1]
    }
    elseif ($Version -match '^(\d+\.\d+\.\d+)$') {
        $TagVersion = "v$Version"
        $FileVersion = $Version
    }

    # ȷܹ
    $Arch = Get-Architecture
    Write-Info "??  ϵͳܹ: $Arch"    # ȷװĿ¼ (̶ΪĬλ)
    Write-Info "? װĿ¼: $InstallDir"

    # װĿ¼
    if (-not (Test-Path $InstallDir)) {
        try {
            New-Item -ItemType Directory -Path $InstallDir -Force | Out-Null
            Write-Success '? װĿ¼'
        }
        catch {
            Write-Error "? Ŀ¼ʧ: $($_.Exception.Message)"
            exit 1
        }
    }    #  URL
    $FileName = "hostsync-$FileVersion-windows-$Arch.exe"
    $DownloadUrl = "https://git.xykqyy.com/ljp/hostSync/releases/download/$TagVersion/$FileName"
    $OutputFile = Join-Path $InstallDir 'hostsync.exe'    # ļ
    if (-not (Get-FileFromUrl $DownloadUrl $OutputFile)) {
        Write-Error '? ʧܣӻֶ'
        Write-Info '? ֶصַ: https://git.xykqyy.com/ljp/hostSync/releases'
        exit 1
    }

    # ֤ļ
    if (-not (Test-Path $OutputFile)) {
        Write-Error '? װļ'
        exit 1
    }

    Write-Success '? HostSync !'    # ӵ PATH
    Write-Info '? û...'
    
    try {
        $currentPath = [Environment]::GetEnvironmentVariable('Path', 'User')
        if ($currentPath -notlike "*$InstallDir*") {
            $newPath = "$currentPath;$InstallDir"
            [Environment]::SetEnvironmentVariable('Path', $newPath, 'User')
            Write-Success '? ӵ PATH '
            Write-Warning '??  նЧ'
        }
        else {
            Write-Info '? PATH ѰװĿ¼'
        }
    }
    catch {
        Write-Warning "??  ûʧ: $($_.Exception.Message)"
        Write-Info "? ֶ '$InstallDir' ӵ PATH"
    }# гʼ
    if (-not $NoInit) {
        Write-Info '? ʼʼ HostSync...'
        
        try {
            # ʹ Start-Process õؿƽִ
            Write-Info "? ִ: $OutputFile init"
            
            $processArgs = @{
                FilePath               = $OutputFile
                ArgumentList           = @('init')
                Wait                   = $true
                PassThru               = $true
                RedirectStandardOutput = $true
                RedirectStandardError  = $true
                WindowStyle            = 'Hidden'
            }
            
            $process = Start-Process @processArgs
            
            if ($process.ExitCode -eq 0) {
                Write-Success '? ʼ!'
            }
            else {
                Write-Warning "??  ʼ˳: $($process.ExitCode)"
                Write-Info '? ҪԱȨޣԺֶ:'
                Write-Info '   ԹԱݴ PowerShell'
                Write-Info '   : hostsync init'
            }
        }
        catch {
            Write-Warning "??  ʼ̳쳣: $($_.Exception.Message)"
            Write-Info '? 볢ֶʼ:'
            Write-Info '   1. ԹԱݴ PowerShell'
            Write-Info "   2. : `"$OutputFile`" init"
            Write-Info '   3. : hostsync init (ӵPATH)'
        }
    }

    # ʾϢ
    Write-Success @"

? HostSync װ!
=====================

? װλ: $OutputFile
? Ŀ¼: $env:USERPROFILE\.hostsync\

? ٿʼ:
"@

    Write-Info '  hostsync list                        # 鿴' 
    Write-Info '  hostsync add test example.com        # '
    Write-Info @'
  hostsync update                      # ½
  hostsync service status              # 鿴״̬

? :
  hostsync help                        # 鿴
  hostsync version                     # 鿴汾

? Ŀַ: https://git.xykqyy.com/ljp/hostSync
'@
}

# 
trap {
    Write-Error "? װз: $($_.Exception.Message)"
    Write-Info '? ӻֶذװ'
    exit 1
}

# ִаװ
Remove-ExistingService
Install-HostSync
